#ifndef __randn_c /* Copyright Bill.Triggs@inrialpes.fr */
#define __randn_c "$ Fri Jul 21 12:01:11 2000 $"
/** NO WARRANTY. Use & distribute freely. Fixes/feedback welcome. **/
/*------------------------------------------------------------------------
  randn() - return a sample from a zero mean unit standard deviation
  Gaussian distribution. It needs a pseudo-random number generator
  DRAND() that returns double precision random numbers uniformly
  distributed on the interval [0,1]. You can use drand48() for this, or,
  e.g. ((double)rand())/RAND_MAX, depending on what your system
  provides.
  ------------------------------------------------------------------------*/
#include <stdlib.h>
#include <math.h>

#ifndef M_PI
# define M_PI 3.14159265358979323846
#endif
#ifndef DRAND
  extern double drand48();
# define DRAND drand48
#endif

double
randn(void)
{
  static double y;
  static int goody=0;
  if (goody)
  {
    goody=0;
    return y;
  }
  else
  {
    double r,theta;
    r=sqrt(-2*log(1-DRAND()));
    theta=2*M_PI*DRAND();
    y=r*sin(theta);
    goody=1;
    return r*cos(theta);
  }
}

#endif /*__randn_c */
